> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getunleash.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server.

# Import feature flags

POST https://app.unleash-instance.example.com/api/admin/features-batch/import
Content-Type: application/json

[Import feature flags](https://docs.getunleash.io/concepts/import-export#import-feature-flags) into a specific project and environment.

Reference: https://docs.getunleash.io/api/import-toggles

## Authentication

- `Authorization` header (required) — API key needed to access this API
- `Authorization` header (bearer token, required) — API key needed to access this API, in Bearer token format

## Request

### Body (application/json)

- `project` (string, required) — The exported [project](https://docs.getunleash.io/concepts/projects)
- `environment` (string, required) — The exported [environment](https://docs.getunleash.io/concepts/environments)
- `data` (object, required) — The result of the export operation, providing you with the feature flag definitions, strategy definitions and the rest of the elements relevant to the features (tags, environments etc.)
  - `features` (list of object, required) — All the exported features.
    - `name` (string, required) — Unique feature name
    - `type` (string, optional) — Type of the flag e.g. experiment, kill-switch, release, operational, permission
    - `description` (string, optional, nullable) — Detailed description of the feature
    - `archived` (boolean, optional) — `true` if the feature is archived
    - `project` (string, optional) — Name of the project the feature belongs to
    - `enabled` (boolean, optional) — `true` if the feature is enabled, otherwise `false`.
    - `stale` (boolean, optional) — `true` if the feature is stale based on the age and feature type, otherwise `false`.
    - `favorite` (boolean, optional) — `true` if the feature was favorited, otherwise `false`.
    - `impressionData` (boolean, optional) — `true` if the impression data collection is enabled for the feature, otherwise `false`.
    - `createdAt` (string, optional, nullable) — The date the feature was created
    - `createdBy` (object, optional) — User who created the feature flag
      - `id` (integer, required) — The user id
      - `name` (string, required) — Name of the user
      - `imageUrl` (string, required) — URL used for the user profile image
    - `archivedAt` (string, optional, nullable) — The date the feature was archived
    - `environments` (list of object, optional) — The list of environments where the feature can be used
      - `name` (string, required) — The name of the environment
      - `enabled` (boolean, required) — `true` if the feature is enabled for the environment, otherwise `false`.
      - `featureName` (string, optional) — The name of the feature
      - `environment` (string, optional) — The name of the environment
      - `type` (string, optional) — The type of the environment
      - `sortOrder` (double, optional) — The sort order of the feature environment in the feature environments list
      - `variantCount` (double, optional) — The number of defined variants
      - `strategies` (list of object, optional) — A list of activation strategies for the feature environment
        - `name` (string, required) — The name or type of strategy
        - `id` (string, optional) — A uuid for the feature strategy
        - `title` (string, optional, nullable) — A descriptive title for the strategy
        - `disabled` (boolean, optional, nullable) — A toggle to disable the strategy. defaults to false. Disabled strategies are not evaluated or returned to the SDKs
        - `featureName` (string, optional) — The name or feature the strategy is attached to
        - `sortOrder` (double, optional) — The order of the strategy in the list
        - `segments` (list of double, optional) — A list of segment ids attached to the strategy
        - `constraints` (list of object, optional) — A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints
          - `contextName` (string, required) — The name of the context field that this constraint should apply to.
          - `operator` (enum, required) — The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators).
            - Allowed values: `NOT_IN`, `IN`, `STR_ENDS_WITH`, `STR_STARTS_WITH`, `STR_CONTAINS`, `NUM_EQ`, `NUM_GT`, `NUM_GTE`, `NUM_LT`, `NUM_LTE`, `DATE_AFTER`, `DATE_BEFORE`, `SEMVER_EQ`, `SEMVER_GT`, `SEMVER_LT`, `SEMVER_GTE`, `SEMVER_LTE`, `REGEX`
          - `caseInsensitive` (boolean, optional, default: false) — Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive).
          - `inverted` (boolean, optional, default: false) — Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa.
          - `values` (list of string, optional) — The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values.
          - `value` (string, optional) — The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values.
        - `variants` (list of object, optional) — Strategy level variants
          - `name` (string, required) — The variant name. Must be unique for this feature flag
          - `weight` (integer, required) — The weight is the likelihood of any one user getting this variant. It is an integer between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information
          - `weightType` (enum, required) — Set to `fix` if this variant must have exactly the weight allocated to it. If the type is `variable`, the weight will adjust so that the total weight of all variants adds up to 1000. Refer to the [variant weight documentation](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight).
            - Allowed values: `variable`, `fix`
          - `stickiness` (string, required) — The [stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) to use for distribution of this variant. Stickiness is how Unleash guarantees that the same user gets the same variant every time
          - `payload` (object, optional) — Extra data configured for this variant
            - `type` (enum, required) — The type of the value. Commonly used types are string, number, json and csv.
            - `value` (string, required) — The actual value of payload
        - `parameters` (map from string to string, optional) — A list of parameters for a strategy
      - `variants` (list of object, optional) — A list of variants for the feature environment
        - `name` (string, required) — The variants name. Is unique for this feature flag
        - `weight` (double, required) — The weight is the likelihood of any one user getting this variant. It is a number between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information
        - `weightType` (enum, optional) — Set to fix if this variant must have exactly the weight allocated to it. If the type is variable, the weight will adjust so that the total weight of all variants adds up to 1000
          - Allowed values: `variable`, `fix`
        - `stickiness` (string, optional) — [Stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) is how Unleash guarantees that the same user gets the same variant every time
        - `payload` (object, optional) — Extra data configured for this variant
          - `type` (enum, required) — The type of the value. Commonly used types are string, number, json and csv.
            - Allowed values: `json`, `csv`, `string`, `number`
          - `value` (string, required) — The actual value of payload
        - `overrides` (list of object, optional) — Overrides assigning specific variants to specific users. The weighting system automatically assigns users to specific groups for you, but any overrides in this list will take precedence.
          - `contextName` (string, required) — The name of the context field used to determine overrides
          - `values` (list of string, required) — Which values that should be overriden
      - `changeRequestIds` (list of double, optional) — Experimental. A list of change request identifiers for actionable change requests that are not Cancelled, Rejected or Approved.
      - `milestoneName` (string, optional) — Experimental: The name of the currently active release plan milestone
      - `milestoneOrder` (double, optional) — Experimental: The zero-indexed order of currently active milestone in the list of all release plan milestones
      - `totalMilestones` (double, optional) — Experimental: The total number of milestones in the feature environment release plan
      - `lastSeenAt` (string, optional, nullable) — The date when metrics where last collected for the feature environment
      - `hasStrategies` (boolean, optional) — Whether the feature has any strategies defined.
      - `hasEnabledStrategies` (boolean, optional) — Whether the feature has any enabled strategies defined.
      - `releasePlans` (list of object, optional) — Release plans for this feature environment
        - `id` (string, required) — The release plan/template's ID. Release template IDs are ulids.
        - `discriminator` (enum, required) — A field to distinguish between release plans and release templates.
          - Allowed values: `plan`
        - `name` (string, required) — The name of the release template.
        - `featureName` (string, required) — The name of the feature that uses this release plan.
        - `environment` (string, required) — The environment that this release plan is for.
        - `createdByUserId` (double, required) — Release template: The ID of the user who created this template.
        - `createdAt` (string, required) — The date and time that the release template was created.
        - `milestones` (list of object, required) — A list of the milestones in this release template.
          - `id` (string, required) — The milestone's ID. Milestone IDs are ulids.
          - `name` (string, required) — The name of the milestone.
          - `sortOrder` (integer, required) — The order of the milestone in the release plan.
          - `releasePlanDefinitionId` (string, required) — The ID of the release plan/template that this milestone belongs to.
          - `startedAt` (string, optional, nullable) — The date and time when the milestone was started.
          - `transitionCondition` (object, optional, nullable) — The condition configuration for the transition
            - `intervalMinutes` (integer, required) — The interval in minutes before transitioning
          - `progressionExecutedAt` (string, optional, nullable) — The date and time when the milestone progression was executed.
          - `pausedAt` (string, optional, nullable) — The date and time when the milestone was paused.
          - `strategies` (list of object, optional) — A list of strategies that are attached to this milestone.
            - `id` (string, required) — The milestone strategy's ID. Milestone strategy IDs are ulids.
            - `milestoneId` (string, required) — The ID of the milestone that this strategy belongs to.
            - `sortOrder` (double, required) — The order of the strategy in the list
            - `name` (string, required) — The name of the strategy type
            - `strategyName` (string, required, deprecated) — The name of the strategy type
            - `title` (string, optional, nullable) — A descriptive title for the strategy
            - `parameters` (map from string to string, optional) — An object containing the parameters for the strategy
            - `constraints` (list of object, optional) — A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints
            - `variants` (list of object, optional) — Strategy level variants
            - `segments` (list of double, optional) — Ids of segments to use for this strategy
            - `disabled` (boolean, optional, nullable) — A toggle to disable the strategy. defaults to false. Disabled strategies are not evaluated or returned to the SDKs
        - `releasePlanTemplateId` (string, required) — The ID of the release plan template that this release plan is based on.
        - `description` (string, optional, nullable) — A description of the release template.
        - `activeMilestoneId` (string, optional, nullable) — The ID of the currently active milestone in this release plan.
        - `safeguards` (list of object, optional) — An array of safeguards configured for this release plan.
          - `id` (string, required) — The unique ULID identifier for this safeguard
          - `action` (object, required) — The action to take when the safeguard is triggered.
            - `type` (string, required) — The type of action to perform.
            - `id` (string, required) — The ID of the release plan this safeguard applies to.
          - `triggerCondition` (object, required) — The condition that triggers the safeguard.
            - `operator` (enum, required) — The comparison operator for the threshold check.
            - `threshold` (double, required) — The threshold value to compare against.
          - `impactMetric` (object, required) — The metric configuration used to evaluate the safeguard condition.
            - `id` (string, required) — The unique identifier for this impact metric
            - `metricName` (string, required) — The Prometheus metric series to query. It includes both unleash prefix and metric type and display name
            - `timeRange` (enum, required) — The time range for the metric data.
            - `aggregationMode` (enum, required) — The aggregation mode for the metric data.
            - `labelSelectors` (map from string to list of string, required) — The selected labels and their values for filtering the metric data.
            - `source` (enum, optional) — The Prometheus data source for this metric. Internal is the Unleash-managed Prometheus, external is a customer-provided Prometheus instance. Defaults to internal if not specified.
      - `safeguards` (list of object, optional) — Safeguards for this feature environment
        - `id` (string, required) — The unique ULID identifier for this safeguard
        - `action` (object, required) — Disable a feature in an environment when triggered.
          - `type` (string, required) — The type of action to perform.
          - `featureName` (string, required) — The feature flag name this safeguard applies to.
          - `environment` (string, required) — The environment this safeguard applies to.
          - `project` (string, required) — The project this safeguard applies to.
        - `triggerCondition` (object, required) — The condition that triggers the safeguard.
          - `operator` (enum, required) — The comparison operator for the threshold check.
            - Allowed values: `>`, `<`
          - `threshold` (double, required) — The threshold value to compare against.
        - `impactMetric` (object, required) — The metric configuration used to evaluate the safeguard condition.
          - `id` (string, required) — The unique identifier for this impact metric
          - `metricName` (string, required) — The Prometheus metric series to query. It includes both unleash prefix and metric type and display name
          - `timeRange` (enum, required) — The time range for the metric data.
            - Allowed values: `hour`, `day`, `week`, `month`
          - `aggregationMode` (enum, required) — The aggregation mode for the metric data.
            - Allowed values: `rps`, `count`, `avg`, `sum`, `p95`, `p99`, `p50`
          - `labelSelectors` (map from string to list of string, required) — The selected labels and their values for filtering the metric data.
          - `source` (enum, optional) — The Prometheus data source for this metric. Internal is the Unleash-managed Prometheus, external is a customer-provided Prometheus instance. Defaults to internal if not specified.
            - Allowed values: `internal`, `external`
      - `yes` (integer, optional) — How many times the feature evaluated to true (enabled)
      - `no` (integer, optional) — How many times the feature evaluated to false (disabled)
    - `tags` (list of object, optional, nullable) — The list of feature tags
      - `value` (string, required) — The value of the tag.
      - `type` (string, required) — The [type](https://docs.getunleash.io/concepts/feature-flags#tags) of the tag
      - `color` (string, optional, nullable) — The hexadecimal color code for the tag type.
    - `children` (list of string, optional) — The list of child feature names. This is an experimental field and may change.
    - `lifecycle` (object, optional) — Current lifecycle stage of the feature
      - `stage` (enum, required) — The name of the current lifecycle stage
        - Allowed values: `initial`, `pre-live`, `live`, `completed`, `archived`
      - `enteredStageAt` (string, required) — When the feature entered this stage
      - `status` (string, optional, nullable) — The name of the detailed status of a given stage. E.g. completed stage can be kept or discarded.
    - `dependencies` (list of object, optional) — The list of parent dependencies. This is an experimental field and may change.
      - `feature` (string, required) — The name of the parent feature
      - `enabled` (boolean, optional) — Whether the parent feature is enabled or not
      - `variants` (list of string, optional) — The list of variants the parent feature should resolve to. Only valid when feature is enabled.
    - `collaborators` (object, optional) — Information related to users who have made changes to this feature flage.
      - `users` (list of object, required) — Users who have made any changes to this feature flags. The list is sorted in reverse chronological order (most recent changes first)
        - `id` (integer, required) — The user's id
        - `name` (string, required) — The user's name, username, or email (prioritized in that order). If none of those are present, this property will be set to the string `unknown`
        - `imageUrl` (string, required) — The URL to the user's profile image
    - `links` (list of object, optional) — The list of links. This is an experimental field and may change.
      - `id` (string, required) — The id of the link
      - `url` (string, required) — The URL the feature is linked to
      - `title` (string, optional, nullable) — The description of the link
      - `feature` (string, optional) — The name of the feature this link belongs to
  - `featureStrategies` (list of object, required) — All strategy instances that are used by the exported features in the `features` list.
    - `name` (string, required) — The name or type of strategy
    - `id` (string, optional) — A uuid for the feature strategy
    - `title` (string, optional, nullable) — A descriptive title for the strategy
    - `disabled` (boolean, optional, nullable) — A toggle to disable the strategy. defaults to false. Disabled strategies are not evaluated or returned to the SDKs
    - `featureName` (string, optional) — The name or feature the strategy is attached to
    - `sortOrder` (double, optional) — The order of the strategy in the list
    - `segments` (list of double, optional) — A list of segment ids attached to the strategy
    - `constraints` (list of object, optional) — A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints
      - `contextName` (string, required) — The name of the context field that this constraint should apply to.
      - `operator` (enum, required) — The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators).
        - Allowed values: `NOT_IN`, `IN`, `STR_ENDS_WITH`, `STR_STARTS_WITH`, `STR_CONTAINS`, `NUM_EQ`, `NUM_GT`, `NUM_GTE`, `NUM_LT`, `NUM_LTE`, `DATE_AFTER`, `DATE_BEFORE`, `SEMVER_EQ`, `SEMVER_GT`, `SEMVER_LT`, `SEMVER_GTE`, `SEMVER_LTE`, `REGEX`
      - `caseInsensitive` (boolean, optional, default: false) — Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive).
      - `inverted` (boolean, optional, default: false) — Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa.
      - `values` (list of string, optional) — The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values.
      - `value` (string, optional) — The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values.
    - `variants` (list of object, optional) — Strategy level variants
      - `name` (string, required) — The variant name. Must be unique for this feature flag
      - `weight` (integer, required) — The weight is the likelihood of any one user getting this variant. It is an integer between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information
      - `weightType` (enum, required) — Set to `fix` if this variant must have exactly the weight allocated to it. If the type is `variable`, the weight will adjust so that the total weight of all variants adds up to 1000. Refer to the [variant weight documentation](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight).
        - Allowed values: `variable`, `fix`
      - `stickiness` (string, required) — The [stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) to use for distribution of this variant. Stickiness is how Unleash guarantees that the same user gets the same variant every time
      - `payload` (object, optional) — Extra data configured for this variant
        - `type` (enum, required) — The type of the value. Commonly used types are string, number, json and csv.
          - Allowed values: `json`, `csv`, `string`, `number`
        - `value` (string, required) — The actual value of payload
    - `parameters` (map from string to string, optional) — A list of parameters for a strategy
  - `tagTypes` (list of object, required) — A list of all of the tag types that are used in the `featureTags` list.
    - `name` (string, required) — The name of the tag type.
    - `description` (string, optional) — The description of the tag type.
    - `icon` (string, optional, nullable) — The icon of the tag type.
    - `color` (string, optional, nullable) — The hexadecimal color code for the tag type.
  - `featureEnvironments` (list of object, optional) — Environment-specific configuration for all the features in the `features` list. Includes data such as whether the feature is enabled in the selected export environment, whether there are any variants assigned, etc.
    - `name` (string, required) — The name of the environment
    - `enabled` (boolean, required) — `true` if the feature is enabled for the environment, otherwise `false`.
    - `featureName` (string, optional) — The name of the feature
    - `environment` (string, optional) — The name of the environment
    - `type` (string, optional) — The type of the environment
    - `sortOrder` (double, optional) — The sort order of the feature environment in the feature environments list
    - `variantCount` (double, optional) — The number of defined variants
    - `strategies` (list of object, optional) — A list of activation strategies for the feature environment
      - `name` (string, required) — The name or type of strategy
      - `id` (string, optional) — A uuid for the feature strategy
      - `title` (string, optional, nullable) — A descriptive title for the strategy
      - `disabled` (boolean, optional, nullable) — A toggle to disable the strategy. defaults to false. Disabled strategies are not evaluated or returned to the SDKs
      - `featureName` (string, optional) — The name or feature the strategy is attached to
      - `sortOrder` (double, optional) — The order of the strategy in the list
      - `segments` (list of double, optional) — A list of segment ids attached to the strategy
      - `constraints` (list of object, optional) — A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints
        - `contextName` (string, required) — The name of the context field that this constraint should apply to.
        - `operator` (enum, required) — The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators).
          - Allowed values: `NOT_IN`, `IN`, `STR_ENDS_WITH`, `STR_STARTS_WITH`, `STR_CONTAINS`, `NUM_EQ`, `NUM_GT`, `NUM_GTE`, `NUM_LT`, `NUM_LTE`, `DATE_AFTER`, `DATE_BEFORE`, `SEMVER_EQ`, `SEMVER_GT`, `SEMVER_LT`, `SEMVER_GTE`, `SEMVER_LTE`, `REGEX`
        - `caseInsensitive` (boolean, optional, default: false) — Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive).
        - `inverted` (boolean, optional, default: false) — Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa.
        - `values` (list of string, optional) — The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values.
        - `value` (string, optional) — The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values.
      - `variants` (list of object, optional) — Strategy level variants
        - `name` (string, required) — The variant name. Must be unique for this feature flag
        - `weight` (integer, required) — The weight is the likelihood of any one user getting this variant. It is an integer between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information
        - `weightType` (enum, required) — Set to `fix` if this variant must have exactly the weight allocated to it. If the type is `variable`, the weight will adjust so that the total weight of all variants adds up to 1000. Refer to the [variant weight documentation](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight).
          - Allowed values: `variable`, `fix`
        - `stickiness` (string, required) — The [stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) to use for distribution of this variant. Stickiness is how Unleash guarantees that the same user gets the same variant every time
        - `payload` (object, optional) — Extra data configured for this variant
          - `type` (enum, required) — The type of the value. Commonly used types are string, number, json and csv.
            - Allowed values: `json`, `csv`, `string`, `number`
          - `value` (string, required) — The actual value of payload
      - `parameters` (map from string to string, optional) — A list of parameters for a strategy
    - `variants` (list of object, optional) — A list of variants for the feature environment
      - `name` (string, required) — The variants name. Is unique for this feature flag
      - `weight` (double, required) — The weight is the likelihood of any one user getting this variant. It is a number between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information
      - `weightType` (enum, optional) — Set to fix if this variant must have exactly the weight allocated to it. If the type is variable, the weight will adjust so that the total weight of all variants adds up to 1000
        - Allowed values: `variable`, `fix`
      - `stickiness` (string, optional) — [Stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) is how Unleash guarantees that the same user gets the same variant every time
      - `payload` (object, optional) — Extra data configured for this variant
        - `type` (enum, required) — The type of the value. Commonly used types are string, number, json and csv.
          - Allowed values: `json`, `csv`, `string`, `number`
        - `value` (string, required) — The actual value of payload
      - `overrides` (list of object, optional) — Overrides assigning specific variants to specific users. The weighting system automatically assigns users to specific groups for you, but any overrides in this list will take precedence.
        - `contextName` (string, required) — The name of the context field used to determine overrides
        - `values` (list of string, required) — Which values that should be overriden
    - `changeRequestIds` (list of double, optional) — Experimental. A list of change request identifiers for actionable change requests that are not Cancelled, Rejected or Approved.
    - `milestoneName` (string, optional) — Experimental: The name of the currently active release plan milestone
    - `milestoneOrder` (double, optional) — Experimental: The zero-indexed order of currently active milestone in the list of all release plan milestones
    - `totalMilestones` (double, optional) — Experimental: The total number of milestones in the feature environment release plan
    - `lastSeenAt` (string, optional, nullable) — The date when metrics where last collected for the feature environment
    - `hasStrategies` (boolean, optional) — Whether the feature has any strategies defined.
    - `hasEnabledStrategies` (boolean, optional) — Whether the feature has any enabled strategies defined.
    - `releasePlans` (list of object, optional) — Release plans for this feature environment
      - `id` (string, required) — The release plan/template's ID. Release template IDs are ulids.
      - `discriminator` (enum, required) — A field to distinguish between release plans and release templates.
        - Allowed values: `plan`
      - `name` (string, required) — The name of the release template.
      - `featureName` (string, required) — The name of the feature that uses this release plan.
      - `environment` (string, required) — The environment that this release plan is for.
      - `createdByUserId` (double, required) — Release template: The ID of the user who created this template.
      - `createdAt` (string, required) — The date and time that the release template was created.
      - `milestones` (list of object, required) — A list of the milestones in this release template.
        - `id` (string, required) — The milestone's ID. Milestone IDs are ulids.
        - `name` (string, required) — The name of the milestone.
        - `sortOrder` (integer, required) — The order of the milestone in the release plan.
        - `releasePlanDefinitionId` (string, required) — The ID of the release plan/template that this milestone belongs to.
        - `startedAt` (string, optional, nullable) — The date and time when the milestone was started.
        - `transitionCondition` (object, optional, nullable) — The condition configuration for the transition
          - `intervalMinutes` (integer, required) — The interval in minutes before transitioning
        - `progressionExecutedAt` (string, optional, nullable) — The date and time when the milestone progression was executed.
        - `pausedAt` (string, optional, nullable) — The date and time when the milestone was paused.
        - `strategies` (list of object, optional) — A list of strategies that are attached to this milestone.
          - `id` (string, required) — The milestone strategy's ID. Milestone strategy IDs are ulids.
          - `milestoneId` (string, required) — The ID of the milestone that this strategy belongs to.
          - `sortOrder` (double, required) — The order of the strategy in the list
          - `name` (string, required) — The name of the strategy type
          - `strategyName` (string, required, deprecated) — The name of the strategy type
          - `title` (string, optional, nullable) — A descriptive title for the strategy
          - `parameters` (map from string to string, optional) — An object containing the parameters for the strategy
          - `constraints` (list of object, optional) — A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints
            - `contextName` (string, required) — The name of the context field that this constraint should apply to.
            - `operator` (enum, required) — The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators).
            - `caseInsensitive` (boolean, optional, default: false) — Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive).
            - `inverted` (boolean, optional, default: false) — Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa.
            - `values` (list of string, optional) — The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values.
            - `value` (string, optional) — The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values.
          - `variants` (list of object, optional) — Strategy level variants
            - `name` (string, required) — The variant name. Must be unique for this feature flag
            - `weight` (integer, required) — The weight is the likelihood of any one user getting this variant. It is an integer between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information
            - `weightType` (enum, required) — Set to `fix` if this variant must have exactly the weight allocated to it. If the type is `variable`, the weight will adjust so that the total weight of all variants adds up to 1000. Refer to the [variant weight documentation](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight).
            - `stickiness` (string, required) — The [stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) to use for distribution of this variant. Stickiness is how Unleash guarantees that the same user gets the same variant every time
            - `payload` (object, optional) — Extra data configured for this variant
          - `segments` (list of double, optional) — Ids of segments to use for this strategy
          - `disabled` (boolean, optional, nullable) — A toggle to disable the strategy. defaults to false. Disabled strategies are not evaluated or returned to the SDKs
      - `releasePlanTemplateId` (string, required) — The ID of the release plan template that this release plan is based on.
      - `description` (string, optional, nullable) — A description of the release template.
      - `activeMilestoneId` (string, optional, nullable) — The ID of the currently active milestone in this release plan.
      - `safeguards` (list of object, optional) — An array of safeguards configured for this release plan.
        - `id` (string, required) — The unique ULID identifier for this safeguard
        - `action` (object, required) — The action to take when the safeguard is triggered.
          - `type` (string, required) — The type of action to perform.
          - `id` (string, required) — The ID of the release plan this safeguard applies to.
        - `triggerCondition` (object, required) — The condition that triggers the safeguard.
          - `operator` (enum, required) — The comparison operator for the threshold check.
            - Allowed values: `>`, `<`
          - `threshold` (double, required) — The threshold value to compare against.
        - `impactMetric` (object, required) — The metric configuration used to evaluate the safeguard condition.
          - `id` (string, required) — The unique identifier for this impact metric
          - `metricName` (string, required) — The Prometheus metric series to query. It includes both unleash prefix and metric type and display name
          - `timeRange` (enum, required) — The time range for the metric data.
            - Allowed values: `hour`, `day`, `week`, `month`
          - `aggregationMode` (enum, required) — The aggregation mode for the metric data.
            - Allowed values: `rps`, `count`, `avg`, `sum`, `p95`, `p99`, `p50`
          - `labelSelectors` (map from string to list of string, required) — The selected labels and their values for filtering the metric data.
          - `source` (enum, optional) — The Prometheus data source for this metric. Internal is the Unleash-managed Prometheus, external is a customer-provided Prometheus instance. Defaults to internal if not specified.
            - Allowed values: `internal`, `external`
    - `safeguards` (list of object, optional) — Safeguards for this feature environment
      - `id` (string, required) — The unique ULID identifier for this safeguard
      - `action` (object, required) — Disable a feature in an environment when triggered.
        - `type` (string, required) — The type of action to perform.
        - `featureName` (string, required) — The feature flag name this safeguard applies to.
        - `environment` (string, required) — The environment this safeguard applies to.
        - `project` (string, required) — The project this safeguard applies to.
      - `triggerCondition` (object, required) — The condition that triggers the safeguard.
        - `operator` (enum, required) — The comparison operator for the threshold check.
          - Allowed values: `>`, `<`
        - `threshold` (double, required) — The threshold value to compare against.
      - `impactMetric` (object, required) — The metric configuration used to evaluate the safeguard condition.
        - `id` (string, required) — The unique identifier for this impact metric
        - `metricName` (string, required) — The Prometheus metric series to query. It includes both unleash prefix and metric type and display name
        - `timeRange` (enum, required) — The time range for the metric data.
          - Allowed values: `hour`, `day`, `week`, `month`
        - `aggregationMode` (enum, required) — The aggregation mode for the metric data.
          - Allowed values: `rps`, `count`, `avg`, `sum`, `p95`, `p99`, `p50`
        - `labelSelectors` (map from string to list of string, required) — The selected labels and their values for filtering the metric data.
        - `source` (enum, optional) — The Prometheus data source for this metric. Internal is the Unleash-managed Prometheus, external is a customer-provided Prometheus instance. Defaults to internal if not specified.
          - Allowed values: `internal`, `external`
    - `yes` (integer, optional) — How many times the feature evaluated to true (enabled)
    - `no` (integer, optional) — How many times the feature evaluated to false (disabled)
  - `contextFields` (list of object, optional) — A list of all the context fields that are in use by any of the strategies in the `featureStrategies` list.
    - `name` (string, required) — The name of the context field
    - `description` (string, optional, nullable) — The description of the context field.
    - `stickiness` (boolean, optional) — Does this context field support being used for [stickiness](https://docs.getunleash.io/concepts/stickiness) calculations
    - `sortOrder` (integer, optional) — Used when sorting a list of context fields. Is also used as a tiebreaker if a list of context fields is sorted alphabetically.
    - `createdAt` (string, optional, nullable) — When this context field was created
    - `usedInFeatures` (integer, optional, nullable) — Number of projects where this context field is used in
    - `usedInProjects` (integer, optional, nullable) — Number of projects where this context field is used in
    - `legalValues` (list of object, optional) — Allowed values for this context field schema. Can be used to narrow down accepted input
      - `value` (string, required) — The valid value
      - `description` (string, optional) — Describes this specific legal value
    - `project` (string, optional) — The project this context field belongs to (if it is project-specific)
  - `featureTags` (list of object, optional) — A list of all the tags that have been applied to any of the features in the `features` list.
    - `featureName` (string, required) — The name of the feature this tag is applied to
    - `tagValue` (string, required) — The value of the tag
    - `tagType` (string, optional) — The [type](https://docs.getunleash.io/concepts/feature-flags#tags) of the tag
    - `createdByUserId` (double, optional, nullable) — The id of the user who created this tag
  - `segments` (list of object, optional) — A list of all the segments that are used by the strategies in the `featureStrategies` list.
    - `id` (double, required)
    - `name` (string, required)
  - `dependencies` (list of object, optional) — A list of all the dependencies for features in `features` list.
    - `feature` (string, required) — The name of the child feature.
    - `dependencies` (list of object, required) — List of parent features for the child feature
      - `feature` (string, required) — The name of the feature we depend on.
      - `enabled` (boolean, optional) — Whether the parent feature should be enabled. When `false` variants are ignored. `true` by default.
      - `variants` (list of string, optional) — The list of variants the parent feature should resolve to. Leave empty when you only want to check the `enabled` status.
  - `links` (list of object, optional) — A list of links for features in `features` list.
    - `feature` (string, required) — The name of the child feature.
    - `links` (list of object, required) — List of feature links
      - `url` (string, required) — The URL the feature is linked to
      - `title` (string, optional, nullable) — The description of the link

## Response

### 200

This response has no body.

## Examples

**Request**

```json
{
  "project": "My awesome project",
  "environment": "development",
  "data": {
    "features": [
      {
        "name": "my-feature",
        "type": "release",
        "description": "best feature ever",
        "archived": false,
        "project": "default",
        "stale": false,
        "impressionData": false
      }
    ],
    "featureStrategies": [
      {
        "name": "flexibleRollout",
        "id": "924974d7-8003-43ee-87eb-c5f887c06fd1",
        "title": "Rollout 50%",
        "disabled": false,
        "featureName": "my-feature",
        "segments": [
          1
        ],
        "constraints": [],
        "parameters": {
          "groupId": "default",
          "rollout": "50",
          "stickiness": "random"
        }
      }
    ],
    "tagTypes": [
      {
        "name": "simple",
        "description": "Used to simplify filtering of features",
        "icon": "#"
      }
    ]
  }
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://app.unleash-instance.example.com/api/admin/features-batch/import"

payload = {
    "project": "My awesome project",
    "environment": "development",
    "data": {
        "features": [
            {
                "name": "my-feature",
                "type": "release",
                "description": "best feature ever",
                "archived": False,
                "project": "default",
                "stale": False,
                "impressionData": False
            }
        ],
        "featureStrategies": [
            {
                "name": "flexibleRollout",
                "id": "924974d7-8003-43ee-87eb-c5f887c06fd1",
                "title": "Rollout 50%",
                "disabled": False,
                "featureName": "my-feature",
                "segments": [1],
                "constraints": [],
                "parameters": {
                    "groupId": "default",
                    "rollout": "50",
                    "stickiness": "random"
                }
            }
        ],
        "tagTypes": [
            {
                "name": "simple",
                "description": "Used to simplify filtering of features",
                "icon": "#"
            }
        ]
    }
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.unleash-instance.example.com/api/admin/features-batch/import';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"project":"My awesome project","environment":"development","data":{"features":[{"name":"my-feature","type":"release","description":"best feature ever","archived":false,"project":"default","stale":false,"impressionData":false}],"featureStrategies":[{"name":"flexibleRollout","id":"924974d7-8003-43ee-87eb-c5f887c06fd1","title":"Rollout 50%","disabled":false,"featureName":"my-feature","segments":[1],"constraints":[],"parameters":{"groupId":"default","rollout":"50","stickiness":"random"}}],"tagTypes":[{"name":"simple","description":"Used to simplify filtering of features","icon":"#"}]}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.unleash-instance.example.com/api/admin/features-batch/import"

	payload := strings.NewReader("{\n  \"project\": \"My awesome project\",\n  \"environment\": \"development\",\n  \"data\": {\n    \"features\": [\n      {\n        \"name\": \"my-feature\",\n        \"type\": \"release\",\n        \"description\": \"best feature ever\",\n        \"archived\": false,\n        \"project\": \"default\",\n        \"stale\": false,\n        \"impressionData\": false\n      }\n    ],\n    \"featureStrategies\": [\n      {\n        \"name\": \"flexibleRollout\",\n        \"id\": \"924974d7-8003-43ee-87eb-c5f887c06fd1\",\n        \"title\": \"Rollout 50%\",\n        \"disabled\": false,\n        \"featureName\": \"my-feature\",\n        \"segments\": [\n          1\n        ],\n        \"constraints\": [],\n        \"parameters\": {\n          \"groupId\": \"default\",\n          \"rollout\": \"50\",\n          \"stickiness\": \"random\"\n        }\n      }\n    ],\n    \"tagTypes\": [\n      {\n        \"name\": \"simple\",\n        \"description\": \"Used to simplify filtering of features\",\n        \"icon\": \"#\"\n      }\n    ]\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.unleash-instance.example.com/api/admin/features-batch/import")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"project\": \"My awesome project\",\n  \"environment\": \"development\",\n  \"data\": {\n    \"features\": [\n      {\n        \"name\": \"my-feature\",\n        \"type\": \"release\",\n        \"description\": \"best feature ever\",\n        \"archived\": false,\n        \"project\": \"default\",\n        \"stale\": false,\n        \"impressionData\": false\n      }\n    ],\n    \"featureStrategies\": [\n      {\n        \"name\": \"flexibleRollout\",\n        \"id\": \"924974d7-8003-43ee-87eb-c5f887c06fd1\",\n        \"title\": \"Rollout 50%\",\n        \"disabled\": false,\n        \"featureName\": \"my-feature\",\n        \"segments\": [\n          1\n        ],\n        \"constraints\": [],\n        \"parameters\": {\n          \"groupId\": \"default\",\n          \"rollout\": \"50\",\n          \"stickiness\": \"random\"\n        }\n      }\n    ],\n    \"tagTypes\": [\n      {\n        \"name\": \"simple\",\n        \"description\": \"Used to simplify filtering of features\",\n        \"icon\": \"#\"\n      }\n    ]\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.unleash-instance.example.com/api/admin/features-batch/import")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"project\": \"My awesome project\",\n  \"environment\": \"development\",\n  \"data\": {\n    \"features\": [\n      {\n        \"name\": \"my-feature\",\n        \"type\": \"release\",\n        \"description\": \"best feature ever\",\n        \"archived\": false,\n        \"project\": \"default\",\n        \"stale\": false,\n        \"impressionData\": false\n      }\n    ],\n    \"featureStrategies\": [\n      {\n        \"name\": \"flexibleRollout\",\n        \"id\": \"924974d7-8003-43ee-87eb-c5f887c06fd1\",\n        \"title\": \"Rollout 50%\",\n        \"disabled\": false,\n        \"featureName\": \"my-feature\",\n        \"segments\": [\n          1\n        ],\n        \"constraints\": [],\n        \"parameters\": {\n          \"groupId\": \"default\",\n          \"rollout\": \"50\",\n          \"stickiness\": \"random\"\n        }\n      }\n    ],\n    \"tagTypes\": [\n      {\n        \"name\": \"simple\",\n        \"description\": \"Used to simplify filtering of features\",\n        \"icon\": \"#\"\n      }\n    ]\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.unleash-instance.example.com/api/admin/features-batch/import', [
  'body' => '{
  "project": "My awesome project",
  "environment": "development",
  "data": {
    "features": [
      {
        "name": "my-feature",
        "type": "release",
        "description": "best feature ever",
        "archived": false,
        "project": "default",
        "stale": false,
        "impressionData": false
      }
    ],
    "featureStrategies": [
      {
        "name": "flexibleRollout",
        "id": "924974d7-8003-43ee-87eb-c5f887c06fd1",
        "title": "Rollout 50%",
        "disabled": false,
        "featureName": "my-feature",
        "segments": [
          1
        ],
        "constraints": [],
        "parameters": {
          "groupId": "default",
          "rollout": "50",
          "stickiness": "random"
        }
      }
    ],
    "tagTypes": [
      {
        "name": "simple",
        "description": "Used to simplify filtering of features",
        "icon": "#"
      }
    ]
  }
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.unleash-instance.example.com/api/admin/features-batch/import");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"project\": \"My awesome project\",\n  \"environment\": \"development\",\n  \"data\": {\n    \"features\": [\n      {\n        \"name\": \"my-feature\",\n        \"type\": \"release\",\n        \"description\": \"best feature ever\",\n        \"archived\": false,\n        \"project\": \"default\",\n        \"stale\": false,\n        \"impressionData\": false\n      }\n    ],\n    \"featureStrategies\": [\n      {\n        \"name\": \"flexibleRollout\",\n        \"id\": \"924974d7-8003-43ee-87eb-c5f887c06fd1\",\n        \"title\": \"Rollout 50%\",\n        \"disabled\": false,\n        \"featureName\": \"my-feature\",\n        \"segments\": [\n          1\n        ],\n        \"constraints\": [],\n        \"parameters\": {\n          \"groupId\": \"default\",\n          \"rollout\": \"50\",\n          \"stickiness\": \"random\"\n        }\n      }\n    ],\n    \"tagTypes\": [\n      {\n        \"name\": \"simple\",\n        \"description\": \"Used to simplify filtering of features\",\n        \"icon\": \"#\"\n      }\n    ]\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "project": "My awesome project",
  "environment": "development",
  "data": [
    "features": [
      [
        "name": "my-feature",
        "type": "release",
        "description": "best feature ever",
        "archived": false,
        "project": "default",
        "stale": false,
        "impressionData": false
      ]
    ],
    "featureStrategies": [
      [
        "name": "flexibleRollout",
        "id": "924974d7-8003-43ee-87eb-c5f887c06fd1",
        "title": "Rollout 50%",
        "disabled": false,
        "featureName": "my-feature",
        "segments": [1],
        "constraints": [],
        "parameters": [
          "groupId": "default",
          "rollout": "50",
          "stickiness": "random"
        ]
      ]
    ],
    "tagTypes": [
      [
        "name": "simple",
        "description": "Used to simplify filtering of features",
        "icon": "#"
      ]
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/features-batch/import")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```